#include	<defs.h>
#include	<types.h>
#include	<qm.h>
#include	<iscan.h>
#include	<bcirc.h>


void bcpoints(ulong *larr,int r,int c,CPTp cpt)
{
	CPLp		cpl;
	QM_link		lblockp;

  lblockp = (QM_link)cpt->qhead;
  while(qm_fnext(cpt->qhead,lblockp,(USERBLOCK **)&cpl)) {
    set_pixel(larr,r,c,cpl->sy,cpl->sx);
    lblockp = cpl->qlink;
  }
}


void fill8(ulong *larr,int r,int c,int i,int j)
{
	int	ni,nj;

  if(!(larr[M2A(i,j,r,c)] & 0x00ffffff)) {
    set_pixel(larr,r,c,i,j);
    for(ni=-1;ni<=1;ni++) {
      for(nj=-1;nj<=1;nj++) {
        fill8(larr,r,c,i+ni,j+nj);
      }
    }
  }
}


void fill4(ulong *larr,int r,int c,int i,int j)
{
	int	ni,nj;

  if(!(larr[M2A(i,j,r,c)] & 0x00ffffff)) {
    set_pixel(larr,r,c,i,j);
    fill4(larr,r,c,i,j-1);
    fill4(larr,r,c,i,j+1);
    fill4(larr,r,c,i-1,j);
    fill4(larr,r,c,i+1,j);
  }
}


void bcircf(ulong *larr,int r,int c,int cx,int cy,int radius,int thk)
{
  bcirc(larr,r,c,cx,cy,radius,thk);
  /* don't use fill8 on Breshenham's circle because it's only 4-connected;
     fill8 will overflow and cover the entire image.
  */
  fill4(larr,r,c,cx,cy);
}


void bcirc(ulong *larr,int r,int c,int cx,int cy,int radius,int thk)
{
        int    x,y,p;
 
  /* Draws circle of given radius and thickness at center       \ 7 | 0 /   
     (cx,cy).  Bcirc() uses Bresenham's aglorithm for drawing    \  |  /    
     the primary arc in octant 0 (see diagram on right).          \ | /     
                                                                6  \|/  1   
     The primary coordinates are them mapped into their        -----|------ 
     corresponding positions.                                   5  /|\  2   
                                                                  / | \     
     For circles of thickness thk < 5 pixels are added to        /  |  \    
     the primary pixel on alternating y+1, y-1 sides.           / 4 | 3 \   
  */
  p = 3 - (2*radius);
  x = 0;  y = radius;
  while(x < y) {
    draw_circ_pixel(larr,r,c,x,y,cx,cy,thk);
    if(p<0) 
      p = p + (4 * x) + 6;
    else {
      p = p + (4 * (x - y)) + 10;
      y = y - 1;
    }
    x = x + 1;
  }
  if(x == y) draw_circ_pixel(larr,r,c,x,y,cx,cy,thk);
}
 

void draw_circ_pixel(ulong *larr,int r,int c,int x,int y,int cx,int cy,int thk)
{
	int	i;

  /* Draws circles of given thickness thk < 5. */
  for(i=1;i<=thk;i++) {
    if(i%2 != 0)	y = y + (i/2);
    else		y = y - (i/2);
    set_circ_pixel(larr,r,c,x,y,cx,cy);
  }
} 


void set_circ_pixel(ulong *larr,int r,int c,int x,int y,int cx,int cy)
{
  /* Map pixels to octants 0 - 7. */
  set_pixel(larr,r,c,cx + x,cy + y);
  set_pixel(larr,r,c,cx - x,cy + y);
  set_pixel(larr,r,c,cx + x,cy - y);
  set_pixel(larr,r,c,cx - x,cy - y);
  set_pixel(larr,r,c,cx + y,cy + x);
  set_pixel(larr,r,c,cx - y,cy + x);
  set_pixel(larr,r,c,cx + y,cy - x);
  set_pixel(larr,r,c,cx - y,cy - x);
}


void set_pixel(ulong *larr,int r,int c,int i,int j)
{
  /* set abgr pixel inverting bgr fields with XOR, preserving alpha channel */
  /* this doesn't work properly because if one pixels gets drawn twice, it
     goes to 0
  larr[M2A(i,j,r,c)] ^= 0x00ffffff;
  */
  /* set abgr pixel inverting bgr fields with OR, preserving alpha channel */
  larr[M2A(i,j,r,c)] |= 0x00ffffff;
}
