#include        <iostream>
#include	<unistd.h>
#include	<cstdio>
#include	<cstdlib>
#include	<cstring>
#include	<cmath>

using namespace std;

#include	<mlib/types.h>
#include	<mlib/array.h>
#include	<mlib/matrix.h>
#include	<mlib/vector.h>
#include	"pnm.h"
#include	"pgm.h"

// prototypes
void	parseCmdLine(int argc,char **argv,int *r,int *c);
int	main(int argc, char **argv);

void parseCmdLine(int argc,char **argv,int *r,int *c)
{
        int     ch;
        int     opterr=0;
        char    *progname, *ptr;
        char    *usage =
		"usage: %s < srcimg.pgm > destimg.pgm                      \n"
                "options:\n"
                "\t -r          \t rows                                    \n"
                "\t -c          \t cols                                    \n"
                "\t -h          \t this help message                       \n"
                ;

  // get basename of argv
  if((ptr = strrchr(*argv,'/')) != NULL)        progname = ++ptr;
  else                                          progname = *argv;

  while((ch = getopt(argc,argv,"hr:c:"))!=EOF) {
    switch(ch) {
      case 'r':
        (*r) = atoi(optarg);
        break;
      case 'c':
        (*c) = atoi(optarg);
        break;
      case 'h':
      default:
        opterr = 1;
        break;
    }
  }

  if(opterr) {
    fprintf(stderr,usage,progname);
    exit(1);
  }
}


int main(int argc, char **argv)
{
	int		nr=0,nc=0;
	Pgm		img(256,256,(ushort)0);

  parseCmdLine(argc,argv,&nr,&nc);

  cin >> img;
  if(nr && nc) img.resize(nr,nc);
  cout << img;
}
