#include        <iostream>
#include	<cstdio>
#include	<cstdlib>
#include	<cstring>
#include	<unistd.h>
#include	<cmath>

using namespace std;

#include	<mlib/types.h>
#include	<mlib/array.h>
#include	<mlib/matrix.h>
#include	<mlib/vector.h>
#include	"pnm.h"
#include	"ppm.h"

// prototypes
void	parseCmdLine(int argc,char **argv,int *angle,int *bilinear);
int	main(int argc, char **argv);

void parseCmdLine(int argc,char **argv)
{
        int     ch;
        int     opterr=0;
        char    *progname, *ptr;
        char    *usage =
		"usage: %s < srcimg.pgm > destimg.pgm                      \n"
                "options:\n"
                "\t -h          \t this help message                       \n"
                ;

  // get basename of argv
  if((ptr = strrchr(*argv,'/')) != NULL)        progname = ++ptr;
  else                                          progname = *argv;

  while((ch = getopt(argc,argv,"hr:b"))!=EOF) {
    switch(ch) {
      case 'h':
      default:
        opterr = 1;
        break;
    }
  }

  if(opterr) {
    fprintf(stderr,usage,progname);
    exit(1);
  }
}


/* draw one circle
int main(int argc, char **argv)
{
	Ppm		img(256,256,(ulong)0);

  parseCmdLine(argc,argv);

  cin >> img;

  img.bcircf(128,128,10,1);

  cout << img;
}
*/

/* draw two (overlapping) circles */
int main(int argc, char **argv)
{
	int		i,x,y;
	Ppm*		imgArea;
	Ppm*		imgOverlay;

  imgArea = new Ppm(256,256,(ulong)0);

  parseCmdLine(argc,argv);

  cin >> imgArea;

  imgOverlay = new Ppm(imgArea);

  for(i=0;i<10;i++) {

      // black out temporary (overlay) img
      imgOverlay->black();

      // get (x,y) in image coordinates (not OpenGL coord's), then draw circle
      x = imgArea->rows() / 2 + i;
      y = imgArea->cols() / 2;
      imgOverlay->bcircf(y,x,10,1);

      // add in the currently drawn circle to output image
      (*imgArea) += imgOverlay;
  }

  cout << imgArea;
}
