#include        <iostream>
#include	<cstdio>
#include	<cstdlib>
#include	<cstring>
#include	<unistd.h>
#include	<cmath>

using namespace std;

#include	<mlib/types.h>
#include	<mlib/array.h>
#include	<mlib/matrix.h>
#include	<mlib/vector.h>
#include	"pnm.h"
#include	"ppm.h"

// prototypes
void	parseCmdLine(int argc,char **argv,int *angle,int *bilinear);
int	main(int argc, char **argv);

void parseCmdLine(int argc,char **argv,int *angle,int *bilinear)
{
        int     ch;
        int     opterr=0;
        char    *progname, *ptr;
        char    *usage =
		"usage: %s < srcimg.pgm > destimg.pgm                      \n"
                "options:\n"
                "\t -r angle    \t CCW rotation                            \n"
                "\t -b          \t turn OFF bilinear interpolation         \n"
                "\t -h          \t this help message                       \n"
                ;

  // get basename of argv
  if((ptr = strrchr(*argv,'/')) != NULL)        progname = ++ptr;
  else                                          progname = *argv;

  while((ch = getopt(argc,argv,"hr:b"))!=EOF) {
    switch(ch) {
      case 'b':
        (*bilinear) = 0;
        break;
      case 'r':
        (*angle) = atoi(optarg);
        break;
      case 'h':
      default:
        opterr = 1;
        break;
    }
  }

  if(opterr) {
    fprintf(stderr,usage,progname);
    exit(1);
  }
}


int main(int argc, char **argv)
{
	int		angle=0,bilinear=1; // turn on interpolation by def.
	Ppm		img(256,256,(ulong)0);

  parseCmdLine(argc,argv,&angle,&bilinear);

  cin >> img;
  img.rotate((double)angle,bilinear);
  cout << img;
}
