#include        <iostream>
#include        <iomanip>
#include	<string.h>
#include	<math.h>

using namespace std;

#include	"matrix.h"
#include	"matrix.cpp"

typedef xxxxx Type;

/////////////////////////// friend operators: (const scalar&, const Matrix&) ///
const Matrix<Type>& operator*(const Type& lhs,const Matrix<Type>& rhs)
{
	Matrix<Type>	result(rhs);

  return(result *= lhs);
}

Matrix<Type> operator/(const Type& lhs,const Matrix<Type>& rhs)
{
	double		prec = 0.001;
	Matrix<Type>	result(rhs);

  // tensor product?  this routine calculates (scalar / matrix), giving
  // [ scalar/element scalar/element ... ]
  // [ scalar/element scalar/element ... ]
  // [ ...                           ... ]

  for(int i=0; i<result.rows(); i++)
    for(int j=0; j<result.cols(); j++)
      result(i,j) =
        // check for div by zero
        fabs(result(i,j) - prec) <= prec ? HUGE : lhs/result(i,j);

  return(result);
}

Matrix<Type> operator+(const Type& lhs,const Matrix<Type>& rhs)
{
	Matrix<Type>	result(rhs);

  return(result += lhs);
}

Matrix<Type> operator-(const Type& lhs,const Matrix<Type>& rhs)
{
	Matrix<Type>	result(rhs);

  result = -result;
  return(result += lhs);
}


/////////////////////////// friends ////////////////////////////////////////////
ostream& operator<<(ostream& s,const Matrix<Type>& rhs)
{
  s.setf(ios::fixed,ios::floatfield);
  s.precision(2);
  for(int i=0; i<rhs.r; i++) {
    s << "[";
    for(int j=0; j<rhs.c; j++) {
      s.width(6);
      j == rhs.c-1 ? s << rhs(i,j) : s << rhs(i,j) << ", ";
    }
    s << "]" << endl;
  }

  return s;
}

template class Matrix<Type>;
