#include        <iostream>
#include        <iomanip>
#include	<math.h>

using namespace std;

#include	"matrix.h"
#include	"vector.h"

/////////////////////////// protected helper functions (for constructors) //////
template <typename Type>
void Vector<Type>::init2d(Type x, Type y)
{
  arr[0] = x;  arr[1] = y;
}

template <typename Type>
void Vector<Type>::init3d(Type x, Type y, Type z)
{
  arr[0] = x;  arr[1] = y;  arr[2] = z;
}

template <typename Type>
void Vector<Type>::init4d(Type x, Type y, Type z, Type w)
{
  arr[0] = x;  arr[1] = y;  arr[2] = z;  arr[3] = w;
}

/////////////////////////// operators: unary ///////////////////////////////////

/////////////////////////// operators: (const Vector&, const Vector&) //////////
template <typename Type>
Vector<Type> Vector<Type>::cross(const Vector<Type>& rhs)
{
	Vector<Type>	result;

  if(c <= rhs.c)		result = rhs;
  else				result = this;

  /* result = this x rhs */
  for(int j=0;j<result.c;j++)
    result.arr[j] = \
        rhs.arr[((result.c+j-1)%result.c)] * \
            arr[((result.c+j+1)%result.c)] - \
            arr[((result.c+j-1)%result.c)] * \
        rhs.arr[((result.c+j+1)%result.c)];

  /* result = rhs x this
  for(int j=0;j<result.c;j++)
     result.arr[j] = \
            arr[((result.c+j-1)%result.c)] * \
        rhs.arr[((result.c+j+1)%result.c)] - \
        rhs.arr[((result.c+j-1)%result.c)] * \
            arr[((result.c+j+1)%result.c)];
  */

  return result;
}

/////////////////////////// operators: (const Vector&, const Matrix&) //////////

/////////////////////////// operators: (const Vector&, scalar) /////////////////

/////////////////////////// friends ////////////////////////////////////////////
template <typename Type>
ostream& operator<<(ostream& s,const Vector<Type>& rhs)
{
  s.setf(ios::fixed,ios::floatfield);
  s.precision(1);
  s << "<";
  for(int i=0;i < rhs.r; i++) {
    for(int j=0;j < rhs.c; j++) {
      s.width(3);
      j == rhs.c-1 ? s << rhs(i,j) : s << rhs(i,j) << ", ";
    }
    s << ">";
  }

  return s;
}

template <typename Type>
istream& operator>>(istream& s,Vector<Type>& rhs)
{
	int	i=0;
	char	c;
	Type	f;

  do {
    s >> f; rhs[i] = f; i++;
  } while( s.get(c) && c != '\n');

  return s;
}
/////////////////////////// public member functions ////////////////////////////
