#ifndef VECTOR_H
#define VECTOR_H

#include	"matrix.h"

template <typename Type>
class Vector : public Matrix<Type> {
	public:
	// constructors (overloaded)
	Vector(int col=3) :
		Matrix<Type>(1,col)                  {};
	Vector(Type *array,int col) :
		Matrix<Type>(array,1,col)            {};
	Vector(Type *array,int row,int col) :
		Matrix<Type>(array,row,col)          {};
	Vector(const Vector& rhs) :
		Matrix<Type>(rhs.arr,rhs.r,rhs.c)    {};
	Vector(Vector *rhs) :
		Matrix<Type>(rhs->arr,rhs->r,rhs->c) {};
	Vector(const Matrix<Type>& m) :
		Matrix<Type>(m)		             {};
	Vector(Matrix<Type>* m) :
		Matrix<Type>(m)		             {};
	Vector(Type x,Type y,Type z,Type w) :
		Matrix<Type>(1,4)                    {init4d(x,y,z,w);}
	Vector(Type x,Type y,Type z) :
		Matrix<Type>(1,3)	             {init3d(x,y,z);}
	Vector(Type x,Type y) :
		Matrix<Type>(1,2)	             {init2d(x,y);}

	// destructors (base class destructor ok)
	//~Vector()			      {delete [] arr;}
	~Vector() { }

	// operators: dereferencing (Fortran-like indeces)--use base class
	Type& operator[](int j)		      { return((*this)(0,j)); }

	// operators: (const Vector&, const Matrix&)

	// operators: (const Vector&, const Vector&)

	// operators (const Vector&, scalar)

	// friends
	friend ostream& operator<<(ostream& s, const Vector& rhs);
	friend ostream& operator<<(ostream& s, Vector *rhs)
	  { return(s << (*rhs)); }
	friend istream& operator>>(istream& s, Vector& rhs);
	friend istream& operator>>(istream& s, Vector *rhs)
	  { return(s >> (*rhs)); }

	// member functions
	Vector	cross(const Vector& rhs);

	// protected: available to this (base) class and subs. derived classes
	protected:
	void		init4d(Type,Type,Type,Type);
	void		init3d(Type,Type,Type);
	void		init2d(Type,Type);

	// private: only available to this class
	private:
};

#endif
