#ifndef TIMER_H
#define TIMER_H

#ifndef NULL
#define NULL 0
#endif

//#ifndef _BOOL
//typedef int bool;
//#endif

class Timer {
	public:
	// constructors
	Timer(double s=0.0, double e=0.0, double t=0.0) : \
		ts(s), \
		te(e), \
		tt(t)
			{ }
	Timer(const Timer& rhs)	: \
		ts(rhs.ts), \
		te(rhs.te), \
		tt(rhs.tt)
			{ }

	// desctructors (default ok)
	// ~Timer()

	// friends
	friend ostream& operator<<(ostream& s, const Timer& rhs);
	friend ostream& operator<<(ostream& s, Timer *rhs)
			{ return(s << (*rhs)); }

	// member functions
	void start();
	void end();
	double elapsed_us() { return tt; }
	double elapsed_ms() { return tt/1000.0; }
	double elapsed_s() { return tt/1000000.0; }
	double stamp_us();

	private:
	double	ts;
	double	te;
	double	tt;
};

#endif
